apiVersion: {{ deployment_apivers }}
kind: {{ deployment_kind }}
metadata:
  labels:
{% if do_backups %}
{% if do_s3 %}
    backups.opsperator.io/driver: s3
{% else %}
    backups.opsperator.io/driver: ssh
{% endif %}
{% if (backups_interval | default('daily')) == 'hourly' %}
    backups.opsperator.io/interval: hourly
    backups.opsperator.io/preferredtime: "{{ backups_hourly_start_minute | default(15)}}"
{% elif (backups_interval | default('daily')) == 'weekly' %}
    backups.opsperator.io/interval: weekly
    backups.opsperator.io/preferredtime: "{{ backups_weekly_start_day | default(0) }}"
{% else %}
    backups.opsperator.io/interval: daily
    backups.opsperator.io/preferredtime: "{{ backups_daily_start_hour | default(2) }}"
{% endif %}
{% if not do_s3 %}
    backups.opsperator.io/secret: backups-{{ mattermost_name }}
    backups.opsperator.io/service: backups-{{ mattermost_name }}
{% elif mattermost_s3_flavor == 'minio' %}
    backups.opsperator.io/secret: {{ minio_name | default('s3') }}-mattermost
    backups.opsperator.io/service: {{ minio_name | default('s3') }}-client
{% elif mattermost_s3_flavor in [ 'ceph', 'rados', 'radosgw' ] %}
    backups.opsperator.io/secret: {{ rgw_name | default('s3') }}-mattermost
    backups.opsperator.io/service: {{ rgw_name | default('s3') }}
{% endif %}
{% endif %}
{% if pki_set | length > 0 %}
    pki.opsperator.io/has-ca: {{ pki_set | join(',') }}
{% endif %}
    {{ network_policy_deployment_label }}: {{ mattermost_name }}
  name: {{ mattermost_name }}
  namespace: {{ namespace }}
spec:
{% if not do_hpa or has_dc.resources | length == 0 %}
  replicas: {{ mattermost_replicas }}
{% endif %}
  revisionHistoryLimit: {{ deploy_revision_history_limit | default(10) }}
  selector:
{% if deployment_kind != 'DeploymentConfig' %}
    matchLabels:
      name: {{ mattermost_name }}
  strategy:
{% if do_s3 %}
    type: RollingUpdate
{% else %}
    type: Recreate
{% endif %}
{% else %}
    name: {{ mattermost_name }}
  strategy:
    resources:
      limits:
        cpu: {{ deploy_pod_cpu_limit }}
        memory: {{ deploy_pod_memory_limit }}
      requests:
        cpu: {{ deploy_pod_cpu_request }}
        memory: {{ deploy_pod_memory_request }}
{% if do_s3 %}
    type: Rolling
{% else %}
    type: Recreate
{% endif %}
{% endif %}
  template:
    metadata:
      labels:
        name: {{ mattermost_name }}
{% if pki_set | length > 0 %}
        pki.opsperator.io/has-ca: {{ pki_set | join(',') }}
{% endif %}
    spec:
{% if do_affinities %}
      affinity:
        podAntiAffinity:
{% if scheduling_affinity_required %}
          requiredDuringSchedulingIgnoredDuringExecution:
          - labelSelector:
              matchExpressions:
              - key: name
                operator: In
                values: [ {{ mattermost_name }} ]
            topologyKey: {{ k8s_affinity_zone_label }}
{% else %}
          preferredDuringSchedulingIgnoredDuringExecution:
          - podAffinityTerm:
              labelSelector:
                matchExpressions:
                - key: name
                  operator: In
                  values: [ {{ mattermost_name }} ]
              topologyKey: {{ k8s_affinity_zone_label }}
            weight: 42
{% endif %}
{% endif %}
      automountServiceAccountToken: false
      containers:
      - env:
        - name: AUTH_METHOD
          value: {{ 'oidc' if (do_lemon) else ('ldap' if (do_ldap) else 'local') }}
        - name: DEBUG
          value: "{% if do_debugs %}yay{% endif %}"
{% if mattermost_db_type == 'percona' %}
        - name: DB_DRIVER
          value: mysql
        - name: DB_NAME
          valueFrom:
            secretKeyRef:
              key: database-name
              name: {{ mtpc_name }}
        - name: DB_HOST
          value: {{ mtpc_name }}-client
        - name: DB_PASS
          valueFrom:
            secretKeyRef:
              key: database-password
              name: {{ mtpc_name }}
        - name: DB_PORT
          value: "3306"
        - name: DB_USER
          valueFrom:
            secretKeyRef:
              key: database-user
              name: {{ mtpc_name }}
{% elif mattermost_db_type in [ 'mariadb', 'mysql' ] %}
        - name: DB_DRIVER
          value: mysql
        - name: DB_NAME
          valueFrom:
            secretKeyRef:
              key: database-name
              name: {{ mtms_name }}
        - name: DB_HOST
          value: {{ mtms_name }}
        - name: DB_PASS
          valueFrom:
            secretKeyRef:
              key: database-password
              name: {{ mtms_name }}
        - name: DB_PORT
          value: "3306"
        - name: DB_USER
          valueFrom:
            secretKeyRef:
              key: database-user
              name: {{ mtms_name }}
{% endif %}
        - name: HTTP_PROXY
{% if proxy_host | default(False) %}
          value: http://{{ proxy_host }}:{{ proxy_port | default('3128') }}
        - name: HTTPS_PROXY
          value: http://{{ proxy_host }}:{{ proxy_port | default('3128') }}
        - name: NO_PROXY
          value: "{% if (no_proxy | default([])) | length > 0 %}{{ no_proxy | join(',') }},{% endif %}.{{ namespace }}.svc.{{ cluster_domain }},.{{ namespace }}.svc,.{{ namespace }},.svc.{{ cluster_domain }},.svc,.{{ cluster_domain }},.local,.{{ root_domain }}"
{% elif squid_address is defined %}
          value: {{ squid_address }}
        - name: HTTPS_PROXY
          value: {{ squid_address }}
        - name: NO_PROXY
          value: "{% if (no_proxy | default([])) | length > 0 %}{{ no_proxy | join(',') }},{% endif %}.{{ namespace }}.svc.{{ cluster_domain }},.{{ namespace }}.svc,.{{ namespace }},.svc.{{ cluster_domain }},.svc,.{{ cluster_domain }},.local,.{{ root_domain }}"
{% else %}
          value: ""
        - name: HTTPS_PROXY
          value: ""
        - name: NO_PROXY
          value: ""
{% endif %}
{% if do_lemon %}
        - name: LLNG_PROTO
          value: https
        - name: LLNG_SSO_DOMAIN
          value: {{ lemon_portal | urlsplit('hostname') }}
{% endif %}
        - name: MM_ADMIN_PASSWORD
          valueFrom:
            secretKeyRef:
              key: admin-password
              name: {{ mattermost_name }}
        - name: MM_ADMIN_USERNAME
          valueFrom:
            secretKeyRef:
              key: admin-user
              name: {{ mattermost_name }}
        - name: MM_DOMAIN
          value: {{ mattermost_fqdn }}
{% if do_lemon %}
        - name: OIDC_CLIENT_ID
          value: mattermost
        - name: OIDC_LOCKOUT
          value: yep
        - name: OIDC_SECRET
          valueFrom:
            secretKeyRef:
              key: mattermost-oauth2-secret
              name: {{ ldap_secret_name }}
{% endif %}
{% if do_ldap %}
        - name: OPENLDAP_BASE
          valueFrom:
            secretKeyRef:
              key: directory-root
              name: {{ ldap_secret_name }}
        - name: OPENLDAP_BIND_DN_PREFIX
          value: cn=mattermost,ou=services
        - name: OPENLDAP_BIND_PW
          valueFrom:
            secretKeyRef:
              key: mattermost-password
              name: {{ ldap_secret_name }}
        - name: OPENLDAP_DOMAIN
          value: {{ root_domain }}
        - name: OPENLDAP_HOST
{% if ldaps_address | default(False) %}
          value: {{ ldaps_address | urlsplit('hostname') }}
        - name: OPENLDAP_PORT
          value: "{{ ldaps_address | urlsplit('port') }}"
        - name: OPENLDAP_PROTO
          value: ldaps
{% else %}
          value: {{ ldap_address | urlsplit('hostname') }}
        - name: OPENLDAP_PORT
          value: "{{ ldap_address | urlsplit('port') }}"
        - name: OPENLDAP_PROTO
          value: ldap
{% endif %}
        - name: OPENLDAP_USER_OBJECTCLASS
{% if do_fusion %}
          value: gosaAccount
{% else %}
          value: {{ mattermost_ldap_user_objectclass }}
{% endif %}
{% endif %}
{% if mattermost_license_secret_name | default(False) %}
        - name: PROMETHEUS_ENABLE
          value: "{{ 'tru' if (do_exporters) else 'fals' }}e"
{% endif %}
        - name: PUBLIC_PROTO
          value: https
{% if do_s3 %}
{% if mattermost_s3_flavor == 'minio' %}
        - name: S3_ACCESS_KEY
          valueFrom:
            secretKeyRef:
              key: access-key
              name: {{ minio_name | default('s3') }}-mattermost
        - name: S3_BUCKET
          valueFrom:
            secretKeyRef:
              key: bucket
              name: {{ minio_name | default('s3') }}-mattermost
        - name: S3_ENDPOINT
          value: {{ minio_api_address }}
        - name: S3_REGION
          valueFrom:
            secretKeyRef:
              key: region
              name: {{ minio_name | default('s3') }}-mattermost
        - name: S3_SECRET_KEY
          valueFrom:
            secretKeyRef:
              key: secret-key
              name: {{ minio_name | default('s3') }}-mattermost
        - name: S3_SIG_V2
          value: "false"
        - name: S3_SSL
          value: "false"
        - name: STORAGE_DRIVER
          value: amazons3
{% elif mattermost_s3_flavor in [ 'ceph', 'rados', 'radosgw' ] %}
        - name: S3_ACCESS_KEY
          valueFrom:
            secretKeyRef:
              key: access-key
              name: {{ rgw_name | default('s3') }}-mattermost
        - name: S3_BUCKET
          valueFrom:
            secretKeyRef:
              key: bucket
              name: {{ rgw_name | default('s3') }}-mattermost
        - name: S3_ENDPOINT
          value: {{ radosgw_api_address }}
        - name: S3_SECRET_KEY
          valueFrom:
            secretKeyRef:
              key: secret-key
              name: {{ rgw_name | default('s3') }}-mattermost
        - name: S3_SIG_V2
          value: "true"
        - name: S3_SSL
          value: "false"
        - name: STORAGE_DRIVER
          value: amazons3
{% else %}
        - name: STORAGE_DRIVER
          value: local
{% endif %}
{% else %}
        - name: STORAGE_DRIVER
          value: local
{% endif %}
        - name: SITE_NAME
          value: {{ mattermost_org_name }}
        - name: SMTP_HOST
{% if smtp_relay | default(False) %}
          value: {{ smtp_relay }}
        - name: SMTP_PORT
          value: "{{ smtp_port | default('25') }}"
{% elif smtp_address | default(False) %}
          value: {{ smtp_address | urlsplit('hostname') }}
        - name: SMTP_PORT
          value: "{{ smtp_address | urlsplit('port') }}"
{% else %}
          value: ""
        - name: SMTP_PORT
          value: ""
{% endif %}
        - name: SMTP_NOREPLY
          value: noreply@{{ root_domain }}
        - name: TZ
          value: {{ timezone }}
        - name: WS_PROTO
          value: wss
{% if do_triggers == False or (opsimages | json_query("[?name=='mattermost'].short"))[0] == False %}
        image: {{ (opsimages | json_query("[?name=='mattermost'].image"))[0] }}
{% endif %}
        imagePullPolicy: {{ pull_policy }}
        livenessProbe:
{% if k8s_flavor == 'openshift' and ocp_major in [ 3, '3' ] %}
          failureThreshold: 29
{% else %}
          failureThreshold: 5
{% endif %}
          httpGet:
            path: /
            port: 8080
          initialDelaySeconds: 30
          periodSeconds: 30
          timeoutSeconds: 15
        name: mattermost
        ports:
        - containerPort: 8080
{% if do_exporters %}
        - containerPort: 9113
{% endif %}
        readinessProbe:
          httpGet:
            path: /
            port: 8080
          initialDelaySeconds: 30
          periodSeconds: 10
          timeoutSeconds: 3
        resources:
          limits:
            cpu: "{{ mattermost_cpu_limit }}"
            memory: "{{ mattermost_memory_limit }}"
          requests:
            cpu: "{{ mattermost_cpu_request }}"
            memory: "{{ mattermost_memory_request }}"
        securityContext:
          allowPrivilegeEscalation: false
{% if not (k8s_flavor == 'openshift' and ocp_major in [ 3, '3' ]) %}
        startupProbe:
          failureThreshold: 29
          initialDelaySeconds: 30
          periodSeconds: 30
          tcpSocket:
            port: 8080
{% endif %}
        volumeMounts:
{% if do_ldap or do_lemon %}
{% if k8s_flavor == 'kubernetes' %}
        - mountPath: /certs
          name: pkiconf
{% endif %}
        - mountPath: /etc/ldap
          name: ldapconf
{% endif %}
        - mountPath: /mattermost/data
          name: data
          subPath: data
        - mountPath: /mattermost/config
          name: data
          subPath: config
        - mountPath: /mattermost/logs
          name: tmp
        - mountPath: /mattermost/plugins
          name: data
          subPath: srvplugins
{% if mattermost_license_secret_name | default(False) %}
        - mountPath: /mattermost/sub/license.mattermost-license
          name: sub
          subPath: mattermost-license
{% endif %}
        - mountPath: /mattermost/client/plugins
          name: data
          subPath: cltplugins
{% if do_backups and not do_s3 %}
{% if do_triggers == False or (opsimages | json_query("[?name=='sshd'].short"))[0] == False %}
      - image: {{ (opsimages | json_query("[?name=='sshd'].image"))[0] }}
        imagePullPolicy: {{ pull_policy }}
{% else %}
      - imagePullPolicy: {{ pull_policy }}
{% endif %}
        livenessProbe:
          initialDelaySeconds: 30
          tcpSocket:
            port: 2222
          timeoutSeconds: 3
        name: sshd
        ports:
        - containerPort: 2222
        resources:
          limits:
            cpu: {{ sshd_cpu_limit }}
            memory: {{ sshd_memory_limit }}
          requests:
            cpu: "{{ sshd_cpu_request }}"
            memory: "{{ sshd_memory_request }}"
        securityContext:
          allowPrivilegeEscalation: false
        volumeMounts:
        - mountPath: /home/backup
          name: tmp
          subPath: bkphome
        - mountPath: /var/backup
          name: tmp
          subPath: bkpvar
        - mountPath: /.ssh/id_rsa.pub
          name: ssh
          subPath: id_rsa.pub
        - mountPath: /backups
          name: data
{% endif %}
      hostAliases:
      - ip: 127.0.0.1
        hostnames:
        - api.segment.io
{% if k8s_resource_nodes_selectors | length > 0 %}
      nodeSelector:
{% for sel in k8s_resource_nodes_selectors %}
        {{ sel.split('=')[0] }}: "{{ sel.split('=')[1] if (sel.split('=') | length > 1) else '' }}"
{% endfor %}
{% endif %}
{% if k8s_flavor == 'kubernetes' or (k8s_flavor == 'openshift' and ocp_major in [ 4, '4' ]) %}
      priorityClassName: opsperator-application
{% endif %}
{% if (rwx_storage | default(False) and rwx_needs_fsgroup | default(False)) and not do_s3 %}
      securityContext:
        fsGroup: {{ rwx_needs_fsgroup }}
{% elif (rwx_storage is not defined and rwo_needs_fsgroup | default(False)) and not do_s3 %}
      securityContext:
        fsGroup: {{ rwo_needs_fsgroup }}
{% else %}
      securityContext: {}
{% endif %}
{% if do_topology_spread_constraints | default(False) %}
      topologySpreadConstraints:
      - labelSelector:
          matchLabels:
            name: {{ mattermost_name }}
        maxSkew: {{ topology_spread_max_skew | default(1) }}
        topologyKey: {{ k8s_affinity_zone_label }}
{% if scheduling_affinity_required %}
        whenUnsatisfiable: DoNotSchedule
{% else %}
        whenUnsatisfiable: ScheduleAnyway
{% endif %}
{% endif %}
      volumes:
{% if do_s3 %}
      - emptyDir: {}
        name: data
{% else %}
      - name: data
        persistentVolumeClaim:
          claimName: {{ mattermost_name }}
{% endif %}
{% if do_ldap or do_lemon %}
      - configMap:
          name: {{ ldap_name | default('ldap') }}-config
        name: ldapconf
{% if k8s_flavor == 'kubernetes' %}
      - name: pkiconf
        projected:
          sources:
          - secret:
              items:
              - key: ca.crt
                path: ca.crt
{% if directory_tls_provider | default(tls_provider) == 'cert-manager' %}
              name: certmanager-{{ certmanager_ca_name | default(cr_name) }}-root-ca
{% else %}
              name: {{ internal_ca_name | default(cr_name) }}-root-ca
{% endif %}
{% endif %}
{% endif %}
{% if mattermost_license_secret_name | default(False) %}
      - name: sub
        secret:
          secretName: {{ mattermost_license_secret_name }}
{% endif %}
{% if do_backups and not do_s3 %}
      - name: ssh
        secret:
          secretName: backups-{{ mattermost_name }}
{% endif %}
      - emptyDir: {}
        name: tmp
{% if do_triggers %}
  triggers:
{% if (opsimages | json_query("[?name=='mattermost'].short"))[0] %}
  - type: ImageChange
    imageChangeParams:
      automatic: true
      containerNames:
      - mattermost
      from:
        kind: ImageStreamTag
        name: {{ (opsimages | json_query("[?name=='mattermost'].short"))[0] }}
        namespace: {{ buildns }}
{% endif %}
{% if do_backups and not do_s3 and (opsimages | json_query("[?name=='sshd'].short"))[0] %}
  - type: ImageChange
    imageChangeParams:
      automatic: true
      containerNames:
      - sshd
      from:
        kind: ImageStreamTag
        name: {{ (opsimages | json_query("[?name=='sshd'].short"))[0] }}
        namespace: {{ buildns }}
{% endif %}
  - type: ConfigChange
{% endif %}
